/* Copyright 2019 Amazon.com, Inc. or its affiliates.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include <stdlib.h>
#include <stdio.h>
#include <gst/gst.h>

extern "C" struct external_element
*g_external_elements_list() __attribute__((weak));

int main (int argc, char **argv)
{
  GstElement *pipeline;

  if (!g_external_elements_list()) {
    fprintf(stderr, "g_external_elements_list not defined\n");
    exit(-1);
  }
  fprintf(stderr, "g_external_elements_list: %p\n", g_external_elements_list());

  gst_init(&argc, &argv);
  pipeline = gst_pipeline_new(NULL);
  gst_element_set_state(pipeline, GST_STATE_PLAYING);
  return 0;
}
