/*
 * Copyright 2020 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 *
 * This file is included by multiple builds.
 */

#include "cocoa_blue_uart_boot.h"

typedef struct MI_WifiUART_DevAttr_s {
    uart_boot_section1 s1;
    uart_boot_section2 s2;
    // Data derived from the UART sections
    // This creates slight duplication of data but avoids
    // calculating these multiple times in different parts of code
    unsigned short  u16Regions_x[2];
    unsigned short  u16Regions_y[2];
    unsigned short  u16Regions_w[2];
    unsigned short  u16Regions_h[2];
    unsigned char   StartPreload;
    unsigned char   StartAudioPreload;
    signed   short  BootReason;
    unsigned char   Section1DataReceived;
} MI_WifiUART_DevAttr_t;

